Subject: Re: [PATCH net-next,v3 0/9] netfilter: flowtable bridge and vlan enhancements

From: Pablo Neira Ayuso <[email-masked]>
Date: Mon, 16 Nov 2020 23:36:15 +0100

On Mon, Nov 16, 2020 at 02:28:44PM -0800, Jakub Kicinski wrote:
> On Mon, 16 Nov 2020 23:18:15 +0100 Pablo Neira Ayuso wrote:
> > On Sat, Nov 14, 2020 at 09:03:47AM -0800, Jakub Kicinski wrote:
> > > On Sat, 14 Nov 2020 15:00:03 +0100 Tobias Waldekranz wrote:  
> > > > On Sat, Nov 14, 2020 at 12:59, Pablo Neira Ayuso <[email-masked]> wrote:  
> > > > > If any of the flowtable device goes down / removed, the entries are
> > > > > removed from the flowtable. This means packets of existing flows are
> > > > > pushed up back to classic bridge / forwarding path to re-evaluate the
> > > > > fast path.
> > > > >
> > > > > For each new flow, the fast path that is selected freshly, so they use
> > > > > the up-to-date FDB to select a new bridge port.
> > > > >
> > > > > Existing flows still follow the old path. The same happens with FIB
> > > > > currently.
> > > > >
> > > > > It should be possible to explore purging entries in the flowtable that
> > > > > are stale due to changes in the topology (either in FDB or FIB).
> > > > >
> > > > > What scenario do you have specifically in mind? Something like VM
> > > > > migrates from one bridge port to another?    
> > > 
> > > Indeed, 2 VMs A and B, talking to each other, A is _outside_ the
> > > system (reachable via eth0), B is inside (veth1). When A moves inside
> > > and gets its veth. Neither B's veth1 not eth0 will change state, so
> > > cache wouldn't get flushed, right?  
> > 
> > The flow tuple includes the input interface as part of the hash key,
> > so packets will not match the existing entries in the flowtable after
> > the topology update. 
> 
> To be clear - the input interface for B -> A traffic remains B.
> So if B was talking to A before A moved it will keep hitting 
> the cached entry.

Yes, Traffic for B -> A still hits the cached entry.

> Are you saying A -> B traffic won't match so it will update the cache,
> since conntrack flows are bi-directional?

Yes, Traffic for A -> B won't match the flowtable entry, this will
update the cache.